package com.loafle.overflow.central.module.domain.service;

import com.loafle.overflow.central.module.domain.dao.DomainMemberDAO;

import com.loafle.overflow.central.module.member.dao.MemberDAO;

import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.domain.DomainMember;
import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.service.central.domain.DomainMemberService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@Service("DomainMemberService")
public class CentralDomainMemberService implements DomainMemberService {

    @Autowired
    private DomainMemberDAO domainMemberDAO;

    @Autowired
    private MemberDAO memberDAO;

    public void regist(DomainMember domainMember) {
        this.domainMemberDAO.save(domainMember);
    }

    public Domain readDomainByMemberID(long id) {
        Member member = this.memberDAO.findOne(id);
        return this.domainMemberDAO.findDomainByMember(member);
    }

    public DomainMember readByMemberEmail(String email) {
        return this.domainMemberDAO.findByMemberEmail(email);
    }

    public List<Member> readAllMemberByDomain(Domain domain) {
        return this.domainMemberDAO.findAllMemberByDomain(domain);
    }

    public List<Member> readAllMemberByDomainID(final long domainID) {
        return this.domainMemberDAO.findAllMemberByDomainID(domainID);
    }

}
