package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.module.infra.dao.InfraServiceDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.infra.InfraService;
import com.loafle.overflow.service.central.infra.InfraServiceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by insanity on 17. 6. 28.
 */
@Service("InfraServiceService")
public class CentralInfraServiceService implements InfraServiceService {

    @Autowired
    InfraServiceDAO infraServiceDAO;

    public InfraService regist(InfraService infraService) throws OverflowException {
        return this.infraServiceDAO.save(infraService);
    }

    public InfraService read(long id) throws OverflowException {
        return this.infraServiceDAO.findOne(id);
    }

    public InfraService readByService(long hostId, int portNumber, String portType) throws OverflowException {
        return this.infraServiceDAO.findByService(hostId, portNumber, portType);
    }
}
