package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaSensorDisplayItemDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaCrawler;
import com.loafle.overflow.model.meta.MetaSensorDisplayItem;
import com.loafle.overflow.service.central.meta.MetaSensorDisplayItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by insanity on 17. 9. 20.
 */
@Service("MetaSensorDisplayItemService")
public class CentralMetaSensorDisplayItemService implements MetaSensorDisplayItemService {
    @Autowired
    private MetaSensorDisplayItemDAO displayItemDAO;

    public MetaSensorDisplayItem regist(MetaSensorDisplayItem item) throws OverflowException {
        return this.displayItemDAO.save(item);
    }

    public MetaSensorDisplayItem read(long id) throws OverflowException {
        return this.displayItemDAO.findOne(id);
    }

    public List<MetaSensorDisplayItem> readAllByCrawler(MetaCrawler crawler) throws OverflowException {
        return this.displayItemDAO.findAllByCrawler(crawler);
    }
}
