package com.loafle.overflow.central.module.sensor.service;

import com.loafle.overflow.central.commons.utils.PageUtil;
import com.loafle.overflow.central.module.sensor.dao.SensorDAO;
import com.loafle.overflow.central.module.sensor.dao.SensorItemDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.sensor.SensorItem;

import com.loafle.overflow.service.central.sensor.SensorItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
@Service("SensorItemService")
public class CentralSensorItemService implements SensorItemService {

    @Autowired
    private SensorItemDAO sensorItemDAO;
    @Autowired
    private SensorDAO sensorDAO;

    @Transactional
    public SensorItem regist(SensorItem sensorItem) throws OverflowException {
        Sensor s = sensorDAO.findOne(sensorItem.getSensor().getId());
        s.setItemCount((short)(s.getItemCount() + 1));
        this.sensorDAO.save(s);
        return this.sensorItemDAO.save(sensorItem);
    }

    @Transactional
    public boolean registAll(List<SensorItem> sensorItemList) throws OverflowException {
        Sensor s = sensorDAO.findOne(sensorItemList.get(0).getSensor().getId());
        s.setItemCount((short)sensorItemList.size());
        this.sensorDAO.save(s);
        this.sensorItemDAO.save(sensorItemList);
        return true;
    }

    public SensorItem read(String id) throws OverflowException {
        return this.sensorItemDAO.findOne(Long.valueOf(id));
    }

    public Page<SensorItem> readAllBySensor(Sensor sensor, PageParams pageParams) throws OverflowException {
        return this.sensorItemDAO.findAllBySensor(sensor, PageUtil.getPageRequest(pageParams));
    }

    @Transactional
    public void remove(SensorItem sensorItem) throws OverflowException {
        Sensor s = sensorItem.getSensor();
        s.setItemCount((short)(s.getItemCount() - 1));
        this.sensorDAO.save(s);
        this.sensorItemDAO.delete(sensorItem);
    }
}
