package com.loafle.overflow.central.module.infra.service;

import com.google.gson.Gson;
import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.model.infra.InfraMachine;
import com.loafle.overflow.model.infra.InfraOS;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.model.meta.MetaInfraVendor;
import com.loafle.overflow.service.central.infra.InfraOSService;

import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 7. 27.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class InfraOSServiceTest {

    @Autowired
    private InfraOSService infraOSService;
    @Autowired
    private ObjectMapper objectMapper;

    @Test
//    @Ignore
    public void registOS() throws Exception {

        InfraOS infraOS = new InfraOS();

        MetaInfraVendor metaInfraVendor = new MetaInfraVendor();
        metaInfraVendor.setId(26);

        infraOS.setVendor(metaInfraVendor);
        infraOS.setMeta("");

        InfraMachine infraMachine = new InfraMachine();
        infraMachine.setId(1);

        MetaInfraType metaInfraType = new MetaInfraType();
        metaInfraType.setId(3);

        infraOS.setMachine(infraMachine);



        this.infraOSService.regist(infraOS);
    }

    @Test
    public void read() throws Exception {

        InfraOS infraOS = this.infraOSService.read(1);
        String json = objectMapper.writeValueAsString(infraOS);
        System.out.println(json);
    }

}